/* ConnectTo.c - connect to a host 
 * Routine to connect to a host.  Parameter is the host address or name 
 * (must be in /etc/hosts!).  Returns zero if unsuccessful. 
 */

#include "header.h"

extern char *inet_ntoa();

int 
ConnectTo(hostname, port_num)
	char 	*hostname;
	u_short	 port_num;
{
	extern 	char *inet_ntoa();

	struct 	sockaddr_in sin;
	struct 	hostent *hostent;
	u_long 	hostaddr;
        int 	sock;

	/* Try interpreting the parameter as an IP address.  
	 * If it seems to parse, use it as-is. 
	 */
	hostaddr = inet_addr(hostname);
	if (hostaddr != -1) {
		bcopy((char *) &hostaddr, (char *) &sin.sin_addr,
		      sizeof(struct in_addr));
	} else {
		/* Not an IP address.  Try resolving the name.  Give up if it
		 * doesn't compute. 
		 */
		hostent = gethostbyname(hostname);
		if (hostent == NULL) {
			printf("Unknown host %s\n", hostname);
			return (1);
		}
		bcopy((char *) *(hostent->h_addr_list), (char *) &sin.sin_addr,
		      sizeof(struct in_addr));
	}

	/*
	 * Create the socket. 
	 */
	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("Socket Error");
		return (1);
	}

	printf("*** Connecting to host %s (%s)\n", hostname,
	       inet_ntoa(sin.sin_addr));
	sin.sin_family = AF_INET;
	sin.sin_port = htons((u_short) port_num);

	/*
	 * Attempt a connection.  Barf if no good. 
	 */
	if (connect(sock, &sin, sizeof(sin)) < 0) {
		printf("Unable to open connection\n");
		return (-1);
	}

        printf("*** Successfully connected to host %s (%s)\n", hostname,
               inet_ntoa(sin.sin_addr));

	/*
	 * Eureka!  Tell the boss. 
	 */
	return sock;
}
