typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    utime_t	utime;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    void_t	vt;
    sockaddr_un	*sockaddr;
    trace_file	*trace_file;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#if	defined(PROTO_ASPATHS)
    asmatch_t	*asp_match;
    asp_range asp_range;
    asp_stack asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#define	L_EOS	258
#define	L_ERROR	259
#define	L_NUMBER	260
#define	L_USEC	261
#define	L_STRING	262
#define	L_HNAME	263
#define	L_KEYWORD	264
#define	L_HEXSTRING	265
#define	L_OCTETSTRING	266
#define	T_DIRECT	267
#define	T_INTERFACE	268
#define	T_INTERFACES	269
#define	T_LCLADDR	270
#define	T_PROTO	271
#define	T_METRIC	272
#define	T_METRICIN	273
#define	T_METRICOUT	274
#define	T_INFINITY	275
#define	T_DOWN	276
#define	T_PARSE	277
#define	T_ADV	278
#define	T_DEFAULT	279
#define	T_DEFAULTS	280
#define	T_YYDEBUG	281
#define	T_YYSTATE	282
#define	T_YYQUIT	283
#define	T_DEBUG	284
#define	T_SYSLOG	285
#define	T_UPTO	286
#define	T_EMERG	287
#define	T_ALERT	288
#define	T_CRIT	289
#define	T_ERR	290
#define	T_WARNING	291
#define	T_NOTICE	292
#define	T_INFO	293
#define	T_ON	294
#define	T_OFF	295
#define	T_GATEWAY	296
#define	T_PREFERENCE	297
#define	T_DEFAULTMETRIC	298
#define	T_NONBROADCAST	299
#define	T_BROADCAST	300
#define	T_TYPE	301
#define	T_POINTOPOINT	302
#define	T_MULTICAST	303
#define	T_NETMASK	304
#define	T_DEFINE	305
#define	T_INTERNAL	306
#define	T_EXTERNAL	307
#define	T_NOP	308
#define	T_NOP1	309
#define	T_NOP_DM	310
#define	T_NOP_ADV	311
#define	T_NOP_PROTO	312
#define	T_NOP_SOCKADDR	313
#define	T_PEERAS	314
#define	T_LOCALAS	315
#define	T_NEIGHBOR	316
#define	T_GROUP	317
#define	T_NOGENDEFAULT	318
#define	T_VERSION	319
#define	T_ACQUIRE	320
#define	T_BGP	321
#define	T_HOLDTIME	322
#define	T_TEST	323
#define	T_KEEP	324
#define	T_SENDBUF	325
#define	T_RECVBUF	326
#define	T_OPEN	327
#define	T_KEEPALIVE	328
#define	T_INDELAY	329
#define	T_OUTDELAY	330
#define	T_ROUTING	331
#define	T_ANALRETENTIVE	332
#define	T_NOAGGRID	333
#define	T_SETPREF	334
#define	T_EGP	335
#define	T_ASPATH	336
#define	T_ORIGIN	337
#define	T_INCOMPLETE	338
#define	T_ANY	339
#define	T_LOOPS	340
#define	T_TAG	341
#define	T_KERNEL	342
#define	T_SYMBOLS	343
#define	T_REMNANTS	344
#define	T_IFLIST	345
#define	T_ROUTES	346
#define	T_HIGHER	347
#define	T_LOWER	348
#define	T_FLASH	349
#define	T_INTERIOR	350
#define	T_BACKGROUND	351
#define	T_LIMIT	352
#define	T_TRUSTEDGATEWAYS	353
#define	T_SOURCEGATEWAYS	354
#define	T_RIP	355
#define	T_NORIPOUT	356
#define	T_NORIPIN	357
#define	T_NOCHECKZERO	358
#define	T_AREA	359
#define	T_SPF	360
#define	T_HELLO	361
#define	T_HELLOINTERVAL	362
#define	T_ROUTERDEADINTERVAL	363
#define	T_PRIORITY	364
#define	T_SNMP	365
#define	T_ICMP	366
#define	T_ROUTERDISCOVERY	367
#define	T_REDIRECT	368
#define	T_NOREDIRECTS	369
#define	T_AUTHTYPE	370
#define	T_AUTHKEY	371
#define	T_NONE	372
#define	T_SIMPLE	373
#define	T_AUTH	374
#define	T_PASSIVE	375
#define	T_SIMPLEX	376
#define	T_STRICTIFS	377
#define	T_SCANINTERVAL	378
#define	T_STATIC	379
#define	T_MARTIANS	380
#define	T_RETAIN	381
#define	T_EXPORT	382
#define	T_IMPORT	383
#define	T_EXACT	384
#define	T_REFINE	385
#define	T_HOST	386
#define	T_MASK	387
#define	T_MASKLEN	388
#define	T_REJECT	389
#define	T_BLACKHOLE	390
#define	T_RESTRICT	391
#define	T_ALLOW	392
#define	T_AS	393
#define	T_ROUTERID	394
#define	T_IGP	395
#define	T_OPTIONS	396
#define	T_NOINSTALL	397
#define	T_NOSEND	398
#define	T_NORESOLV	399
#define	T_MARK	400
#define	T_TRACEOPTIONS	401
#define	T_EXCEPT	402
#define	T_REPLACE	403
#define	T_SIZE	404
#define	T_FILES	405
#define	T_K	406
#define	T_M	407
#define	T_ALL	408
#define	T_ROUTE	409
#define	T_STATE	410
#define	T_POLICY	411
#define	T_NORMAL	412
#define	T_GENERAL	413
#define	T_TASK	414
#define	T_TIMER	415
#define	T_NOSTAMP	416
#define	T_UPDATE	417
#define	T_DETAIL	418
#define	T_SEND	419
#define	T_RECEIVE	420
#define	T_ERROR	421
#define	T_PACKETS	422
#define	T_RESPONSE	423
#define	T_REQUEST	424
#define	T_OTHER	425
#define	T_TRAP	426
#define	T_AGGREGATE	427
#define	T_GENERATE	428
#define	T_BRIEF	429
#define	T_INET	430
#define	T_GENDEFAULT	431


extern YYSTYPE yylval;
