/* Hack. Because included in a .c file !!!!!!!!!!!!!!!!!!!!!!1 :-(
 */
#define RNBBY   8
#define MAXKEYBITS      (SOCK_MAXADDRLEN * RNBBY)
#define MAXDEPTH        (MAXKEYBITS+1)

typedef struct _radix_node {
    struct _radix_node  *rnode_left;            /* child when bit clear */
    struct _radix_node  *rnode_right;           /* child when bit set */
    struct _radix_node  *rnode_parent;          /* parent */
    u_short     rnode_bit;                      /* bit number for node/mask */
    u_char      rnode_tbyte;                    /* byte to test in address */
    u_char      rnode_tbit;                     /* bit to test in byte */
    rt_head     *rnode_rth;                     /* our external info */
} radix_node;

typedef struct _rt_table {
    struct _rt_table    *rt_table_next; /* next table in list */
    radix_node  *rt_table_tree;         /* current root of tree */
    struct sock_info *rt_table_sinfo;   /* stuff we need to grok sockaddr's */
    u_long      rt_table_inodes;        /* number of internal nodes in tree */
    u_long      rt_table_routes;        /* number of routes in tree */
} rt_table;

#define RT_TREETOP(af)  (rt_tables[(af)] ? \
	rt_tables[af]->rt_table_tree : (radix_node *) 0)

extern rt_table *rt_tables[];
extern rt_table *rt_table_list;


#define PORT_TASK_NAME		"PORT_TASK_NAME"
#define PORT_DEFAULT_PORT	7667
#define SKIPFIRST	1
#define NOSKIPFIRST	0

/* The protocol unit to transfert the routing table
 */
#define RTP_MAXAS PA_PATH_MAXSEGLEN	/* Max AS path lengh. Why mot :-) */

typedef struct _rt_head_proto {
	sockaddr_un rtp_dest;		/* Destination */
	sockaddr_un rtp_dest_mask;	/* Mask for the destination */
	byte rtp_entries;		/*Number of routes to this destination*/
	byte rtp_n_announce;		/* number of announcement */
	flag_t rtp_state;		/* State ???? C.f. gated code !!! */
	sockaddr_un rtp_nexthop;	/* The next hop */
	as_t rtp_localas;		/* Our local AS */
	as_t rtp_peeras;		/* peer's AS */
	metric_t rtp_metric;		/* The metric for this route */
	int rtp_aspathlen;		/* Number of AS in the path */
	as_t rtp_aspath[RTP_MAXAS];	/* Table of AS path */
} rt_head_proto;

/* The local data the the job tasks. Used to lookup the radix tree
 */
typedef struct _port_job_data {
	task *tp_recv;			/* The receiving task */
	int af;
	radix_node *head;
	rt_table *Xrt_table;
	radix_node *Xstack[MAXDEPTH];
	radix_node **Xsp;
	radix_node *Xrn;
	rt_head *rth;
	int count;			/* to prevent loops*/
	flag_t req_type;			/* Type of request */
} port_job_data;

#define REQ_ASCII	BIT(0x1)
#define REQ_DUMP	BIT(0x2)

#define PT_ENDDUMP	'\0'		/* End of dumping */
#define PT_DUMPASCII	' '		/* Dump in ascii format */
#define PT_DUMPBIN	'1'		/* Dump in binary */
#define PT_EOF		'\0'		/* Close the connection */

#define	RT_TABLES_GLOBAL(af, Xrt_table, skipfirst) \
    do { \
	for ((Xrt_table) = ((skipfirst) == SKIPFIRST && (Xrt_table))? \
			(Xrt_table)->rt_table_next: (Xrt_table); \
	     (Xrt_table); \
	     (Xrt_table) = (Xrt_table)->rt_table_next) { \
	    (af) = (Xrt_table)->rt_table_sinfo->si_family;

#define	RT_TABLES_GLOBAL_END(skipfirst) \
	    (skipfirst) = 0; \
	} \
    } while (0)

#define	RT_WALK_GLOBAL(head, rth, Xstack, Xsp, Xrn, skipfirst) \
    do { \
	while (Xrn) { \
	    if ((skipfirst) != SKIPFIRST && ((rth) = Xrn->rnode_rth))

#define	RT_WALK_END_GLOBAL(head, rth, Xstack, Xsp, Xrn, skipfirst) \
	    (skipfirst) = 0; \
	    if (Xrn->rnode_left) { \
		if (Xrn->rnode_right) { \
		    *Xsp++ = Xrn->rnode_right; \
		} \
		Xrn = Xrn->rnode_left; \
	    } else if (Xrn->rnode_right) { \
		Xrn = Xrn->rnode_right; \
	    } else if (Xsp != Xstack) { \
		Xrn = *(--Xsp); \
	    } else { \
		Xrn = (radix_node *) 0; \
		(rth) = (rt_head *) 0; \
	    } \
	} \
    } while (0)

#define TEST_PRINT(ftc, fdump, tjp) \
	if ((ftc) == EOF) { \
		trace_log_tp(port_task_listen, 0, LOG_ERR, \
			("port_dump_job: fprinf failed: %m\n")); \
		close_port(fdump, tjp); \
		return; \
	}

/* Some stuff for writing to socket
 */
#define BUFF global_static_write_buff	/* :-) */

/* Non formated write */
#define WRITE(buff, len, tp_recv) \
        if (write((tp_recv)->task_socket, buff, len) <= 0) { \
                task_job *tjp = (task_job *)(tp_recv)->task_data; \
                if (tjp) { \
                        task_block_free(port_job_data_index, \
                                (caddr_t)tjp->task_job_data); \
                        task_job_delete(tjp); \
                } \
                trace_log_tp((tp_recv), 0, LOG_ERR, \
                        ("WRITE: write error; %m; disconnecting...\n")); \
                port_term_job((task_job *)(tp_recv)->task_data); \
                task_delete(tp_recv); \
		(tp_recv) = NULL; \
                return; \
        }

/* Formated write */
#define WRITEF(sprintfarg, tp_recv) \
	if (write((tp_recv)->task_socket, \
		(gd_sprintf sprintfarg, global_static_write_buff), \
		strlen(global_static_write_buff)) \
		<= 0) { \
		task_job *tjp = (task_job *)(tp_recv)->task_data; \
		if (tjp) { \
			task_block_free(port_job_data_index, \
				(caddr_t)tjp->task_job_data); \
			task_job_delete(tjp); \
		} \
		trace_log_tp((tp_recv), 0, LOG_ERR, \
			("WRITEF: write error; %m; disconnecting...\n")); \
		port_term_job((task_job *)(tp_recv)->task_data); \
		task_delete(tp_recv); \
		(tp_recv) = NULL; \
		return; \
	}

void port_init();
void port_task_dump();
void port_listen_accept();
void port_bg_rt_dump();
void port_dump_job();
void port_dump_rth();
void close_port();
void port_recv_dump();
void port_dump_aspath();
void port_recv();
void port_term_job();
rt_head *rt_radix_first();
rt_head *rt_radix_next();
